
-- just so you can beat boss levels
-- literally the only reason i did this

addHook("BossThinker", function(mo)
	if mo.health == 0 return end
	
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or p.mo.skin ~= "sunky" continue end
		
		local bz = ((p.mo.eflags & MFE_VERTICALFLIP) and mo.floorz) or mo.ceilingz
		local b = P_SpawnMobj(mo.x, mo.y, bz, MT_SUNKY_WINATLIFE)
		b.z = $-b.height
		--b.flags = $1|MF_MISSILE
		b.flags = $1|MF_NOCLIPHEIGHT
		b.target = p.mo
		b.scale = p.mo.scale
		b.spritexscale = FU/2
		b.spriteyscale = FU/2
		mo.sunkyboss = true
		mo.flags = MF_SHOOTABLE|MF_NOTHINK
		return true
	end
end)

local function boxcol(mo, b)
	if mo.z > b.z+b.height
	or b.z > mo.z+mo.height
	or not (b.flags & MF_SHOOTABLE)
	or b.health <= 0
	or b == mo.target return end
	
	if b.sunkyboss
		b.flags = b.info.flags
	end
	P_KillMobj(b, mo, mo.target, DMG_INSTAKILL)
	P_KillMobj(mo)
end

addHook("MobjCollide", boxcol, MT_SUNKY_WINATLIFE)
addHook("MobjMoveCollide", boxcol, MT_SUNKY_WINATLIFE)

addHook("MobjThinker", function(mo)
	local grav = abs(P_GetMobjGravity(mo))
	P_SetObjectMomZ(mo, grav/2, true)
end, MT_SUNKY_WINATLIFE)